<?php

namespace App\Traits;

trait Controller
{
    /**
     * 筛选合法参数
     * @param $where
     * @return \__|array
     * @throws \Exception
     */
    public function filter($where)
    {
        if (is_null($where) || empty($where)) {
            return [];
        }
        require __DIR__."/../Functions/underscore.php";
        $query_fields = null;
        isset($this->query_fields) && $query_fields = $this->query_fields;
        is_string($query_fields) && $query_fields = [$query_fields];
        if ($query_fields)
        {
            if (trim($query_fields[0]) == "*") {
                return $where;
            }
            return __()->pick($where,__()->intersection($this->query_fields,__()->keys($where)));
        }
        return $where;
    }

    public function setBlurSearch($model,$where,$key,$condition = "like")
    {
        if (is_null($where)) {
            return $model;
        }
        if (!in_array($key,array_keys($where))) {
            return $model::where($where);
        }
        $where[$key] = trim($where[$key]);
        $result_model = null;
        switch ($condition) {
            case "like":
                $result_model = $model::where($key,"like","%".$where[$key]."%");
                break;
            case "elt":
                $result_model = $model::where($key,"<=","'$where[$key]'");
                break;
            case "lt":
                $result_model = $model::where($key,"<=","'$where[$key]'");
                break;
            case "gt":
                $result_model = $model::where($key,">","'$where[$key]'");
                break;
            case "egt":
                $result_model = $model::where($key,">=","'$where[$key]'");
                break;
            case "eq":
                $result_model = $model::where($where);
                break;
            case "in":
                $result_model = $model::whereIn($key,"in",$where[$key]);
                break;
        }
        unset($where[$key]);
        try {
            $result_model = $result_model->where($where);
        } catch (\Exception $e) {

        }
        return $result_model;
    }

    public function csrf($data,$key) {
       return preg_replace("/<script[^>]*>.*<\/script>/i","",$data[$key]);
    }
}